const _Http = getApp().globalData.http;
Page({
    data: {
        navList: [{
            label: "我负责的",
            icon: "icon-webxialaxuanxiangjiantou",
            color: "",
            width: "",
            id: "1"
        }, {
            label: "排序",
            icon: "icon-jiangxu1",
            color: "",
            width: "",
            id: "sort"
        }, {
            label: "筛选",
            icon: "icon-shaixuan",
            color: "",
            width: "",
            id: "2"
        }],
        content: {
            isend: 0,
            nocache: true,
            "type": 1,
            deleted: 0,
            "pageNumber": 1,
            "pageSize": 20,
            "isExport": 0,
            "where": {
                "condition": "",
                "status": "", //状态
                "startdate": "",
                "enddate": ""
            },
            "sort": [{
                sortname: "默认",
                sorted: 1,
                sortid: 67,
                reversed: 0
            }]
        },
        list: [],
        classShow: false, //type类型
        filter: {
            show: false,
            status: ['潜在', '合作中', '已终止'],
            statusActive: "",
            startdate: "",
            enddate: ""
        }
    },
    /* 去添加 */
    toAdd() {
        wx.navigateTo({
            url: './addAndEditor'
        })
    },
    onLoad(options) {
        this.setData({
            insert: wx.getStorageSync('auth').wCustomer.options.some(v => v == 'insert'), //查询新增权限
            classActions: wx.getStorageSync('templetList').map(v => {
                return {
                    name: v.templetname,
                    index: v.templetid
                }
            }),
            'navList[0].label': wx.getStorageSync('templetList')[0].templetname,
            "content.type": wx.getStorageSync('templetList')[0].templetid,
        });
        this.getList()
    },
    /* 筛选状态选择 */
    selectStatus(e) {
        const {
            item
        } = e.currentTarget.dataset;
        this.setData({
            "filter.statusActive": this.data.filter.statusActive == item ? "" : item
        })
    },
    /* 筛选日期范围 */
    changeDate(e) {
        const name = e.currentTarget.dataset.name,
            value = e.detail.value;
        this.setData({
            [`filter.${name}`]: value
        })
    },
    /* 处理筛选 */
    handleFilter({
        detail
    }) {
        const data = this.data.filter;
        switch (detail) {
            case 'confirm':
                this.setData({
                    'content.where.status': data.statusActive,
                    'content.where.startdate': data.startdate,
                    'content.where.enddate': data.enddate,
                    'filter.show': false
                });
                this.getList(true);
                break;
            case 'reset':
                this.setData({
                    'filter.statusActive': "",
                    'filter.startdate': "",
                    'filter.enddate': "",
                });
                break;
            case 'close':
                this.setData({
                    'filter.show': false
                });
                break;
        }
    },
    getList(init = false) {
        //init 用于初始化分页
        if (init.detail != undefined) init = init.detail;
        if (init) this.setData({
            ['content.pageNumber']: 1
        })
        if (this.data.content.pageNumber > this.data.content.pageTotal) return;
        console.log(this.data.content)
        _Http.basic({
            "id": 20221012164402,
            content: this.data.content
        }).then(res => {
            console.log("客户列表", res)
            this.selectComponent('#ListBox').RefreshToComplete();
            if (res.msg != '成功') return wx.showToast({
                title: res.msg,
                icon: "none"
            })
            this.setData({
                'content.pageNumber': res.pageNumber + 1,
                'content.pageTotal': res.pageTotal,
                'content.total': res.total,
                'content.sort': res.sort,
                list: res.pageNumber == 1 ? res.data : this.data.list.concat(res.data)
            })
            this.getTags();
        })
    },
    /* 获取列表标签 */
    getTags() {
        let list = this.data.list,
            ownerids = list.map(v => v.sa_customersid)
        _Http.basic({
            "id": 20221018102001,
            "content": {
                "ownertable": "sa_customers",
                ownerids
            }
        }).then(res => {
            for (let key in res.data) {
                let index = list.findIndex(v => v.sa_customersid == key);
                list[index].tags = res.data[key]
            };
            this.setData({
                list
            })
        })
    },
    /* 顶部条件导航回调 */
    navClick({
        detail
    }) {
        switch (detail.id) {
            case '1':
                this.setData({
                    classShow: true
                })
                break;
            case '2':
                this.setData({
                    'filter.show': true
                })
                break;
            case '3':
                this.setData({
                    'content.sort[0].reversed': this.data.content.sort[0].reversed == 0 ? 1 : 0
                });
                this.getList(true)
                break;
            default:

                break;
        }
    },
    /* 处理搜索 */
    onSearch({
        detail
    }) {
        this.setData({
            "content.where.condition": detail
        });
        this.getList(true);

    },
    classClose() {
        this.setData({
            classShow: false
        })
    },
    classSelect({
        detail
    }) {
        if (this.data.content.type == detail.index) return this.classClose();
        this.setData({
            "content.type": detail.index,
            'navList[0].label': detail.name
        })
        this.classClose();
        this.getList(true)
    },
    onReady() {
        this.selectComponent("#ListBox").setHeight(".total", this);
    },
    onShareAppMessage() {}
})